from django.utils.functional import SimpleLazyObject
from . import auth


def get_user(request):
    if not hasattr(request, '_cached_user'):
        request._cached_user = auth.get_user(request)
    return request._cached_user


class AuthenticationMiddleware:
    def __init__(self, get_response):
        self.get_response = get_response

    def __call__(self, request):
        if not getattr(request, 'user'):
            request.user = SimpleLazyObject(lambda: get_user(request))
        response = self.get_response(request)
        return response
